///home/berryj/link/bin/genMethods "-g" "-t" "Set<char*>" "-h" "List" "-I" "LINK/basic/Set.h" "-I" "LINK/basic/List.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Set<char*> _Set_char__;
typedef List<Set<char*> > _List_Set_char___;
static List<Set<char*> > s__List_Set_char___;

#define _List_Set_char___DATA(x) ((List<Set<char*> >*) (EXTDATA(x)))
#define _List_Set_char___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Set<char*> > >::type))
#define _List_Set_char___ISNT_DATA(x) (!_List_Set_char___IS_DATA(x))

#define _List_Set_char___CXX_DATA(x) (*(List<Set<char*> >*) (EXTDATA(VAL(x))))
#define _List_Set_char___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Set<char*> > >::type))
#define _List_Set_char___CXX_ISNT_DATA(x) (!_List_Set_char___CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Set_char___()
{
	Wrapper<_List_Set_char___>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Set_char___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Set_char__>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Set_char__>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Set_char__>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Set_char___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Set_char___Methods(void);

PRIMITIVE STk_init_methods__List_Set_char___()
{
	STk_add_new_cpp_primitive("List-Set-char-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_char__>::makeLinkList);
	STk_add_new_cpp_primitive("List-Set-char?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_char__>::linkListP);
	STk_add_new_cpp_primitive("list->List-Set-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_char__>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Set-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Set_char__>::linkList2STkList);
	genExtra_List_Set_char___Methods();
	return UNDEFINED;
}
